/* Execute given examples with prompt
 * compile: auto via Makefile* or manually cc|bcc|cl [-DFS_LINUX] examples.c [-o execute] 
 * invoke : execute [-io=g | -io=t] myexename [myexename ...]
 *
 * Note: the FlagShip application <myexename> must be compiled with the 
 * same -io=g or -io=t switch as the 1st parameter here, if such is used
 *
 * Copyright 2012 by multisoft Datentechnik, Germany
 * Public domain, you may freely modify and use it. 
 */
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

int main(int argc, char **argv)
{
   int ii, iAll = 0, iStart = 1, iPrompt = 0;
   char in[6], preCommand[50], command[200];
   preCommand[0] = 0;
   
   if(argc > 1) {  
#ifdef FS_LINUX   
      if(strcmp(argv[1], "-io=g") == 0) {
         strcpy(preCommand, "./");
         iStart++;
      } else if(strcmp(argv[1], "-io=t") == 0) {
         strcpy(preCommand, "newfswin ./");
         iStart++;
      }
#else
      if(strcmp(argv[1], "-io=g") == 0 ||
         strcmp(argv[1], "-io=t") == 0)  {
         iStart++;
      }
#endif
   }
   for(ii = iStart; ii < argc; ) {
      if(iAll) {
         printf("Executing '%s%s'\n", preCommand, argv[ii]);
      } else {
         printf("Execute '%s%s' [Enter,Y,y=yes | N,n=no | A,a=all | Esc,Q,q=quit] ? ", preCommand, argv[ii] );
         fgets(&(in[0]), 5, stdin); 
         iPrompt = in[0];
      }
      switch (iPrompt) {
         case '\n' :
         case 'y'  :
         case 'Y'  :
            strcpy(command, preCommand);
            strcat(command, argv[ii]);
            system(command);
            ii++;
            break;
         case 'a':
         case 'A':
            iPrompt = 'y';
            iAll = 1;
            break;      
         case 27 :
         case 'q':
         case 'Q':
            return 1;
         case 'n'  :
         case 'N'  :
            ii++;
            break;
      }
   }
   return 0;
}
/* eof */
